//+------------------------------------------------------------------+
//|                                                  ZZ MTF XO A.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright " ZZ MTF XO A "
#property link      " ZZ MTF XO A "

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 LimeGreen
#property indicator_color2 Red
#property indicator_color3 MediumSeaGreen
#property indicator_color4 Crimson
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 1
#property indicator_width4 1

#property indicator_level1 1.0
#property indicator_level2 2.0
#property indicator_level3 3.0
#property indicator_level4 4.0

#property indicator_maximum 7
#property indicator_minimum 0

extern double KirPER = 7;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   SetIndexStyle(0,DRAW_ARROW,EMPTY);
   SetIndexArrow(0, 159);
   SetIndexBuffer(0,ExtMapBuffer1);

   SetIndexStyle(1,DRAW_ARROW,EMPTY);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexArrow(1, 159);

   SetIndexStyle(2,DRAW_ARROW,EMPTY);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexArrow(2, 167);
   
   SetIndexStyle(3,DRAW_ARROW,EMPTY);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexArrow(3, 167);

   return(0);
}

static int mode = 0;
static int mode240 = 0;

double xo(int shift, int period)
{
   double cur = Close[shift];
   double hi = iCustom(Symbol(), period, "XO_ext", KirPER, 2, iBarShift(Symbol(), period, Time[shift], false)+1);
   double lo = iCustom(Symbol(), period, "XO_ext", KirPER, 3, iBarShift(Symbol(), period, Time[shift], false)+1);

   if (cur > (hi+KirPER * Point))
      return(1.0);

   if (cur < (lo-KirPER*Point)) 
      return(-1.0);

   double val = iCustom(Symbol(), period, "XO_ext", KirPER, 0, iBarShift(Symbol(), period, Time[shift], false)+1);
   if (val == 0.0)
      val = iCustom(Symbol(), period, "XO_ext", KirPER, 1, iBarShift(Symbol(), period, Time[shift], false)+1);

   return(val);
}

int start()
{
   datetime TimeArray[];
   int limit,y=0,counted_bars=IndicatorCounted();

   for(int i=Bars - counted_bars - 1; i>=0; i--)
   {
      double val240 = xo(i, PERIOD_H4);
      double val60 = xo(i, PERIOD_H1);
      double val30 = xo(i, PERIOD_M30);
      double val15 = xo(i, PERIOD_M15);
      double val5 = xo(i, PERIOD_M5);

      if ((val60 == 1.0) && (val30 == 1.0) && (val15 == 1.0) && (val5 == 1.0))
         mode = 1;
      else if ((val60 == -1.0) && (val30 == -1.0) && (val15 == -1.0) && (val5 == -1.0))
         mode = -1;
      else if (i == 0)
      {
         if (ExtMapBuffer1[1] == -1.0)
            mode = -1;
         else
            mode = 1;
      }

      if (val240 == 1.0)
         mode240 = 1;
      else if (val240 == -1.0)
         mode240 = -1;
      else if (i == 0)
      {
         if (ExtMapBuffer3[1] == -1.0)
            mode240 = -1;
         else
            mode240 = 1;
      }

      double value = 0.0;
      
      if (mode == 1)
      {
         if (val60 == 1.0) value++;
         if (val30 == 1.0) value++;
         if (val15 == 1.0) value++;
         if (val5 == 1.0) value++;

         ExtMapBuffer1[i] = value;
         ExtMapBuffer2[i] = -1.0;
      }
      else if (mode == -1)
      {
         if (val60 == -1.0) value++;
         if (val30 == -1.0) value++;
         if (val15 == -1.0) value++;
         if (val5 == -1.0) value++;

         ExtMapBuffer2[i] = value;
         ExtMapBuffer1[i] = -1.0;
      }
      
      if (mode240 == 1)
      {
         ExtMapBuffer3[i] = 6.0;
         ExtMapBuffer4[i] = -1.0;
      }
      else if (mode240 == -1)
      {
         ExtMapBuffer3[i] = -1.0;
         ExtMapBuffer4[i] = 6.0;
      }
   }
   
   return(0);
}

